
#ifdef YUSUF_MULTICORE
#include "RobboLito.h"
#include "YUSUF.h"
#include <signal.h>

static void FAIL_LOW (int x)
{
  // history;
  annullare (&ROOT_POSIZIONE[x], ROOT_POSIZIONE[x].DIN->mossa & 0x7fff);
}

static void TOT_rekurs (int b) /* LOCK (MUTEX); */
{
  uint64 K;
  YUSUF_TOT[b] = VERO;
  K = KINDER[b];
  while (K)
    {
      b = BSF (K);
      TOT_rekurs (b);
      bitLIBERO(b, K);
    }
}

static void FAIL_HIGH(SPLITPUNKT *sp, int x)
{
  uint32 m;
  uint64 K;
  int b;
  // hash;
  // history;
  m = ROOT_POSIZIONE[x].DIN->mossa & 0x7fff;
  annullare (&ROOT_POSIZIONE[x], ROOT_POSIZIONE[x].DIN->mossa & 0x7fff);
  LOCK_SP (sp);
  if (sp->tot)
    {
      UNLOCK_SP (sp);
      return;
    }
  sp->tot = VERO;
  UNLOCK_SP (sp);
  LOCK (MUTEX);
  K = KINDER[sp->thr_eltern];
  while (K)
    {
      b = BSF (K);
      TOT_rekurs (b);
      bitLIBERO(b, K);
    }
  UNLOCK (MUTEX);
  LOCK_SP (sp);
  sp->mossa = m & 0x7fff;
  sp->yr = sp->beta;
  sp->final = YUSUF_BETA;
  UNLOCK_SP (sp);
}

#define VERBOTEN(z)\
  ( (z).bianco_en_mossa ? (z).DIN->nero_re_scacco : (z).DIN->bianco_re_scacco)
static logico grab_work(SPLITPUNKT *sp, int x)
{
  uint32 m;
  LOCK_SP (sp);
 A:
  if (sp->tot || !sp->rima)
    {
      UNLOCK_SP (sp);
      return FALSO;
    }
  m = sp->ML[sp->n++].mossa & 0x7fff;
  sp->rima--;
  sp->v = YUSUF_MIX (sp->rima, sp->abisso);
  if (sp->rima && sp->v < YUSUF_TIEF)
    YUSUF_TIEF = sp->v;
  fare (&ROOT_POSIZIONE[x], m);
  valutazione (&ROOT_POSIZIONE[x], -0x7fff0000, 0x7fff0000, m);
  if (VERBOTEN (ROOT_POSIZIONE[x]))
    {
      annullare (&ROOT_POSIZIONE[x], m);
      goto A;
    }
  UNLOCK_SP (sp);
  return VERO;
}

static logico do_work (SPLITPUNKT *sp, int scout, int thr)
{
  int j;
  int v;
  j = setjmp (YUSUF_JMP[thr]);
  if (j)
    {
      return FALSO;
    }
  if (ROOT_POSIZIONE[thr].bianco_en_mossa)
    {
      if (ROOT_POSIZIONE[thr].DIN->bianco_re_scacco)
	v = -nodo_tagliato_scacco_bianco
	  (&ROOT_POSIZIONE[thr], 1 - scout, sp->abisso + sp->shah);
      else 
	v = -nodo_tagliato_bianco (&ROOT_POSIZIONE[thr], 1 - scout, sp->abisso);
    }
  else
    {
      if (ROOT_POSIZIONE[thr].DIN->nero_re_scacco)
	v = -nodo_tagliato_scacco_nero
	  (&ROOT_POSIZIONE[thr], 1 - scout, sp->abisso + sp->shah);
      else 
	v = -nodo_tagliato_nero (&ROOT_POSIZIONE[thr], 1 - scout, sp->abisso);
    }
  if (v < scout)
    FAIL_LOW (thr);
  else if (!sp->pv)
    FAIL_HIGH (sp, thr);
  else
    {
      if (ROOT_POSIZIONE[thr].bianco_en_mossa)
	{
	  logico b = (ROOT_POSIZIONE[thr].DIN->bianco_re_scacco != 0);
	  v = -nodo_pv_bianco
	    (&ROOT_POSIZIONE[thr], -sp->beta, -sp->alpha,
	     sp->abisso + b * sp->shah, b); 
	}
      else
	{
	  logico b = (ROOT_POSIZIONE[thr].DIN->nero_re_scacco != 0);
	  v = -nodo_pv_nero
	    (&ROOT_POSIZIONE[thr], -sp->beta, -sp->alpha,
	     sp->abisso + b * sp->shah, b); 
	}
      if (v >= sp->beta)
	FAIL_HIGH (sp, thr);
      else
	{
	  annullare (&ROOT_POSIZIONE[thr], ROOT_POSIZIONE[thr].DIN->mossa & 0x7fff);
	  if (v > sp->alpha)
	    {
	      LOCK_SP (sp);
	      sp->alpha = v;
	      UNLOCK_SP (sp);
	    }
	}
    }
  return VERO;  
}

static void thread_werke (SPLITPUNKT *sp, int cpu, int thr)
{
  LOCK_SP (sp);
  sp->c++;
  UNLOCK_SP (sp);
  while (VERO)
    {
      if (!grab_work (sp, thr))
	break;
      if (!do_work (sp, sp->beta, thr))
	break;
    }
  LOCK_SP (sp);
  if (!sp->tot)
    {
      sp->final = YUSUF_ALPHA;
      sp->yr = sp->alpha;
    }
  KINDER[sp->thr_eltern] &= ~(1ULL << thr);
  UNLOCK_SP (sp);
  LOCK (MUTEX);
  CPUS_USED &= ~(1ULL << cpu); // ?
  THREADS_USED &= ~(1ULL << thr);
  YUSUF_TOT[thr] = FALSO;
  UNLOCK (MUTEX);
  LOCK_SP (sp);
  sp->c--;
  if (sp->c == 0)
    {
      pthread_mutex_lock (&COND_WAIT_LOCK[sp->thr_eltern]);
      pthread_cond_signal (&COND_WAIT[sp->thr_eltern]);
      pthread_mutex_unlock (&COND_WAIT_LOCK[sp->thr_eltern]);
    }
  UNLOCK_SP (sp);
}

#undef mucchio_altezzo
#undef MUCCHIO

static logico werke
(SPLITPUNKT *sp, int thread)
{
  int cpu;
  int h;
  uint64 T;
  int b = thread;
  LOCK (MUTEX);
  T = CPUS_MASK & ~CPUS_USED;
  if (!T)
    {
      UNLOCK (MUTEX);
      return FALSO;
    }
  cpu = BSF (T);
  CPUS_USED |= (1ULL << cpu);
  THREADS_USED |= (1ULL << thread);
  YUSUF_TOT[thread] = FALSO;
  UNLOCK (MUTEX);
  LOCK_SP (sp);
  KINDER[sp->thr_eltern] |= (1ULL << thread);
  UNLOCK_SP (sp);

  memcpy (&ROOT_POSIZIONE[b], &ROOT_POSIZIONE[sp->thr_eltern], 356);
  memcpy (ROOT_POSIZIONE[b].din_iniz, ROOT_POSIZIONE[sp->thr_eltern].DIN - 1,
	  2 * sizeof (tipo_dinamico));
  ROOT_POSIZIONE[b].DIN = ROOT_POSIZIONE[b].din_iniz + 1;
  h = ROOT_POSIZIONE[sp->thr_eltern].mucchio_altezzo;
  memcpy (ROOT_POSIZIONE[b].MUCCHIO,
	  ROOT_POSIZIONE[sp->thr_eltern].MUCCHIO, h * sizeof(uint64));
  ROOT_POSIZIONE[b].mucchio_altezzo = h;
  ROOT_POSIZIONE[b].cpu = cpu;
  ROOT_POSIZIONE[b].thread = thread;
  thread_werke (sp, cpu, thread);
  return VERO;
}

static SPLITPUNKT* new_splitpunkt /* LOCK(MUTEX) */
(int thr, int abisso, int rima, tipo_lista_mossa *ML, int n, int beta, int alpha)
{
  int v;
  SPLITPUNKT *sp;
  int e = -1;
  int i;
  v = YUSUF_MIX (abisso, rima);
  for (i = 0; i < MAX_SP; i++)
    {
      LOCK_SP (&SP[i]);
      if (!SP[i].aktiv)
	e = i;
      UNLOCK_SP (&SP[i]);
    }
  if (e != -1)
    sp = &SP[e];
  else
    return NULL;
  LOCK_SP (sp);
  sp->v = v;
  sp->beta = beta;
  sp->alpha = alpha;
  if (sp->beta == sp->alpha)
    {
      sp->pv = FALSO;
      sp->alpha--;
      sp->shah = 3;
    }
  else
    {
      sp->pv = VERO;  
      sp->shah = 1;
    }
  sp->rima = rima;
  sp->ML = ML;
  sp->abisso = abisso;
  sp->thr_eltern = thr;
  sp->final = 0;
  sp->aktiv = VERO;
  sp->n = n;
  sp->c = 0;
  sp->num = e;
  sp->tot = FALSO;
  sp->yr = -32767;
  UNLOCK_SP (sp);
  return sp;
}

static void endpunkt /* LOCK(sp) */
(SPLITPUNKT *sp)
{
  sp->eltern = -1;
  sp->aktiv = FALSO;
  sp->v = 0;
}

static void spin_lock (int);

static logico SPLIT
(tipo_posizione *POSIZIONE, int abisso, int rima,
 tipo_lista_mossa *ML, int n, int beta, int alpha, int *yr)
{
  SPLITPUNKT *sp;
  int u;
  int b;
  int r;
  int c;
  int z;
  uint64 X;
  //  printf("SPLIT %lld %d/%d %llx/%llx\n",
  //  orologio()-O0,rima,abisso,CPUS_USED,THREADS_USED);
  LOCK (MUTEX);
  if (CPUS_USED == CPUS_MASK)
    {
      UNLOCK (MUTEX);
      return FALSO;
    }
  sp = new_splitpunkt (POSIZIONE->thread, abisso, rima, ML, n, beta, alpha);
  UNLOCK (MUTEX);
  if (!sp)
    return FALSO;

  KINDER[sp->thr_eltern] = 0;
  u = sp->rima;
  LOCK (MUTEX);
  CPUS_USED &= ~(1ULL << POSIZIONE->cpu);
  X = THREADS_MASK & ~THREADS_USED;
  z = MINIMO (u, MINIMO (POPCNT (CPUS_MASK & ~CPUS_USED), POPCNT (X)));
  if (z == 0)
    {
      endpunkt (sp);
      UNLOCK (MUTEX);
      return FALSO;
    }
  LOCK (SPIN_LOCK);
  while (X && z)
    {
      b = BSF (X);
      bitLIBERO (b, X);
      z--;
      pthread_mutex_lock (&COND_WAIT_LOCK[b]);
      pthread_cond_signal (&COND_WAIT[b]);
      pthread_mutex_unlock (&COND_WAIT_LOCK[b]);
    }
  UNLOCK (MUTEX);

  int t = POSIZIONE->thread;
  pthread_mutex_lock (&COND_WAIT_LOCK[t]);
  UNLOCK (SPIN_LOCK);
  pthread_cond_wait (&COND_WAIT[t], &COND_WAIT_LOCK[t]);
  pthread_mutex_unlock (&COND_WAIT_LOCK[t]);

  LOCK (MUTEX);
  CPUS_USED |= (1ULL << POSIZIONE->cpu); // ?
  UNLOCK (MUTEX);
  LOCK_SP (sp);
  if (sp->final == YUSUF_BETA)
    POSIZIONE->DIN->mossa = sp->mossa;
  else
    POSIZIONE->DIN->mossa = 0;
  endpunkt (sp);
  r = sp->final;
  *yr = sp->yr;
  UNLOCK_SP (sp);
  if (r == YUSUF_KEINE)
    return FALSO;
  return VERO;
}

static logico suche_werke
(int thread)
{
  int w = 0;
  int wi = -1;
  int i;
  for (i = 0; i < MAX_SP; i++)
    {
      LOCK_SP (&SP[i]);
      if (SP[i].aktiv && !SP[i].tot && SP[i].v > w)
	{
	  w = SP[i].v;
	  wi = i;
	}
      UNLOCK_SP (&SP[i]);
    }
  if (!w)
    return FALSO;
  return werke (&SP[wi], thread);
}

static void spin_lock
(int thread)
{
  while (VERO)
    {
      pthread_mutex_lock (&COND_WAIT_LOCK[thread]);
      pthread_cond_wait (&COND_WAIT[thread], &COND_WAIT_LOCK[thread]);
      pthread_mutex_unlock (&COND_WAIT_LOCK[thread]);
      LOCK (SPIN_LOCK);
      UNLOCK (SPIN_LOCK);
      while (suche_werke (thread));
    }
}

static void* neu_thread
(void* A)
{
  tipo_yusuf *AA;
  AA = (tipo_yusuf*) A;
  spin_lock (AA->b);
  pthread_exit (NULL);
}

void iniz_SP()
{
  int i;
  uint64 M;
  int b;
  for (i = 0; i < MAX_SP; i++)
    {
      SP[i].v = 0;
      SP[i].aktiv = FALSO;
      SP[i].num = i;
      SP[i].eltern = -1;
    }
  for (i = 0; i < MAX_THREADS; i++)
    ROOT_POSIZIONE[i].sp_num = -1;
  CPUS_USED = 1;
  THREADS_USED = 1;
  M = THREADS_MASK ^ 1;
  while (M)
    {
      b = BSF (M);
      bitLIBERO (b, M);
      ARGS[b].b = b;
      pthread_create (&PTHREAD[b], NULL, neu_thread, (void*) (ARGS+b));
    }
}

void ende_SP()
{
  uint64 M;
  int b;
  M = THREADS_MASK ^ 1;
  while (M)
    {
      b = BSF (M);
      bitLIBERO (b, M);
      pthread_cancel (PTHREAD[b]);
    }  
}

uint8 MIX[256]=
{
    0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 1, 1,  2, 2, 3, 3,
    4, 4, 5, 5,  6, 6, 7, 7,  8, 8, 9, 9, 10,10,11,11,
   12,12,13,13, 14,14,15,15, 16,16,17,17, 18,18,19,19,
   20,20,21,21, 22,22,23,23, 24,24,25,25, 26,26,27,27,

   28,28,28,28, 29,29,29,29, 30,30,30,30, 31,31,31,31,
   32,32,32,32, 33,33,33,33, 34,34,34,34, 35,35,35,35,
   36,36,36,36, 37,37,37,37, 38,38,38,38, 39,39,39,39,
   40,40,40,40, 41,41,41,41, 42,42,42,42, 43,43,43,43,

   44,44,44,44, 44,44,44,44, 45,45,45,45, 45,45,45,45,
   46,46,46,46, 46,46,46,46, 47,47,47,47, 47,47,47,47,
   48,48,48,48, 48,48,48,48, 49,49,49,49, 49,49,49,49,
   50,50,50,50, 50,50,50,50, 51,51,51,51, 51,51,51,51,

   52,52,52,52, 52,52,52,52, 52,52,52,52, 52,52,52,52,
   53,53,53,53, 53,53,53,53, 53,53,53,53, 53,53,53,53,
   54,54,54,54, 54,54,54,54, 54,54,54,54, 54,54,54,54,
   55,55,55,55, 55,55,55,55, 55,55,55,55, 55,55,55,55
};

logico YUSUF_SPLIT
(tipo_prossimo *PROSSIMO, int abisso, tipo_posizione *POSIZIONE, int beta, int *r)
{
  int rima;
  logico b;
  /*  rima = PROSSIMO->nummer - PROSSIMO->mossa; */
  if (rima < 5)
    return FALSO;
  b =  SPLIT (POSIZIONE, abisso, rima, PROSSIMO->LISTA, PROSSIMO->mossa, beta, beta, r);
  if (!b)
    return FALSO;
  return VERO;
}

logico YUSUF_SPLIT_PV
(tipo_prossimo *PROSSIMO, int abisso,
 tipo_posizione *POSIZIONE, int beta, int alpha, int *r)
{
  logico b;
  int rima;
  /*  rima = PROSSIMO->nummer - PROSSIMO->mossa; */
  if (rima < 5)
    return FALSO;
  b =  SPLIT (POSIZIONE, abisso, rima, PROSSIMO->LISTA, PROSSIMO->mossa, beta, alpha, r);
  if (!b)
    return FALSO;
  return VERO;
}

#endif
